﻿Imports System.Text
Imports System.Threading.Tasks

Namespace SolSoft.DataBinding.WpfDemo
	''' <summary>
	''' Simple class for implementing ICommand with delegates
	''' </summary>
	Friend Class DelegateCommand
		Implements ICommand
		Private ReadOnly m_canExecute As Func(Of Object, Boolean)
		Private ReadOnly m_execute As Action(Of Object)

		Public Sub New(ByVal canExecute As Func(Of Object, Boolean), ByVal execute As Action(Of Object))
			m_canExecute = canExecute
			m_execute = execute
		End Sub

		Public Sub New(ByVal canExecute As Func(Of Boolean), ByVal execute As Action)
			'create closures that ignore the parameter
			m_canExecute = Function(ignored) canExecute()
            m_execute = Function(ignored) execute
        End Sub

		Public Event CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged
		Protected Overridable Sub OnCanExecuteChanged(ByVal args As EventArgs)
            RaiseEvent CanExecuteChanged(Me, args)
        End Sub

		Public Function CanExecute(ByVal parameter As Object) As Boolean Implements ICommand.CanExecute
			Return m_canExecute(parameter)
		End Function

		Public Sub Execute(ByVal parameter As Object) Implements ICommand.Execute
			m_execute(parameter)
		End Sub



	End Class
End Namespace
