﻿Imports System.Text
Imports System.Threading.Tasks

Namespace SolSoft.DataBinding.WpfDemo
	''' <summary>
	''' Interaction logic for MainWindow.xaml
	''' </summary>
	Partial Public Class MainWindow
		Inherits Window
		Public Sub New()
			InitializeComponent()

            'set up bindings
            Dim forNaming As MainViewModel = Nothing 'get rid of if you use nameof
            textBoxValue1.SetBinding(TextBox.TextProperty, ObjectNamingExtensions.GetName(Function() forNaming.Value1))
			textBoxValue2.SetBinding(TextBox.TextProperty, ObjectNamingExtensions.GetName(Function() forNaming.Value2))
			textBoxValue3.SetBinding(TextBox.TextProperty, ObjectNamingExtensions.GetName(Function() forNaming.Value3))
			textBoxValue4.SetBinding(TextBox.TextProperty, ObjectNamingExtensions.GetName(Function() forNaming.Value4))
			textBoxValueTotal.SetBinding(TextBox.TextProperty, New Binding With {.Path = New PropertyPath(ObjectNamingExtensions.GetName(Function() forNaming.TotalValue)), .Mode = BindingMode.OneWay})

			gridValues.SetBinding(Grid.IsEnabledProperty, ObjectNamingExtensions.GetName(Function() forNaming.IsEnabled))
			buttonGenerate.SetBinding(Button.CommandProperty, ObjectNamingExtensions.GetName(Function() forNaming.GenerateValuesCommand))
			buttonClear.SetBinding(Button.CommandProperty, ObjectNamingExtensions.GetName(Function() forNaming.ClearValuesCommand))
			buttonQuit.SetBinding(Button.CommandProperty, ObjectNamingExtensions.GetName(Function() forNaming.QuitCommand))

			gridProgress.SetBinding(Grid.VisibilityProperty, New Binding With {.Path = New PropertyPath(ObjectNamingExtensions.GetName(Function() forNaming.IsBusy)), .Converter = New BooleanToVisibilityConverter()})
		End Sub

		Public Property ViewModel() As MainViewModel
			Get
				Return TryCast(DataContext, MainViewModel)
			End Get
			Set(ByVal value As MainViewModel)
				DataContext = value
			End Set
		End Property
	End Class
End Namespace
