﻿Imports System
Imports System.ComponentModel
Imports System.Linq
Imports System.Text

Namespace SolSoft.DataBinding
    ''' <summary>
    ''' Extensions for working with events
    ''' </summary>
    Public Module EventExtensions
        ''' <summary>
        ''' Safely raises the given event
        ''' </summary>
        <System.Runtime.CompilerServices.Extension>
        Public Sub Raise(ByVal eventToRaise As EventHandler, ByVal sender As Object, ByVal eventArgs As EventArgs)
            If eventToRaise IsNot Nothing Then
                eventToRaise.Invoke(sender, eventArgs)
            End If
        End Sub

        ''' <summary>
        ''' Safely raises the given event
        ''' </summary>
        <System.Runtime.CompilerServices.Extension>
        Public Sub Raise(Of TEventArgs As EventArgs)(ByVal eventToRaise As EventHandler(Of TEventArgs), ByVal sender As Object, ByVal eventArgs As TEventArgs)
            If eventToRaise IsNot Nothing Then
                eventToRaise.Invoke(sender, eventArgs)
            End If
        End Sub

        ''' <summary>
        ''' Safely raises the given event
        ''' </summary>
        <System.Runtime.CompilerServices.Extension>
        Public Sub Raise(ByVal eventToRaise As PropertyChangedEventHandler, ByVal sender As Object, ByVal eventArgs As PropertyChangedEventArgs)
            If eventToRaise IsNot Nothing Then
                eventToRaise.Invoke(sender, eventArgs)
            End If
        End Sub

    End Module
End Namespace
