﻿Imports System.Linq
Imports System.Text

Namespace SolSoft.DataBinding
	''' <summary>
	''' Represents a property that has a name and value.  
	''' </summary>
	''' <typeparam name="TValue">Type of the property value</typeparam>
	Public Interface IProperty(Of TValue)
		Inherits INotifyValueChanged
		''' <summary>
		''' Gets the name of this property
		''' </summary>
		ReadOnly Property Name() As String

		''' <summary>
		''' Gets the current value of this property
		''' </summary>
		ReadOnly Property Value() As TValue
	End Interface
End Namespace
