﻿Imports System.ComponentModel
Imports System.Diagnostics.CodeAnalysis
Imports System.Linq
Imports System.Text

Namespace SolSoft.DataBinding
	''' <summary>
	''' Interface representing an object that can be told to raise <see cref="INotifyPropertyChanged.PropertyChanged"/> 
	''' </summary>
	Public Interface IRaisePropertyChanged
		Inherits INotifyPropertyChanged
		''' <summary>
		''' Raises the <see cref="INotifyPropertyChanged.PropertyChanged"/> event on this object.  It is recommended that this method be explicitly implemented
		''' </summary>
		''' <param name="propertyName">Name of the property that has changed</param>
		<SuppressMessage("Microsoft.Design", "CA1030:UseEventsWhereAppropriate")>
		Sub RaisePropertyChanged(ByVal propertyName As String)
	End Interface
End Namespace
